"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const xmldom_1 = require("xmldom");
class DOMStore {
    constructor(writable) {
        this.writable = writable;
    }
    static readEncodingName(document) {
        const node = document.firstChild;
        function isProcessingInstruction(node) {
            var _a;
            return ((_a = node) === null || _a === void 0 ? void 0 : _a.nodeType) === 7; // Node.PROCESSING_INSTRUCTION_NODE;
        }
        if (!isProcessingInstruction(node) || node.target !== 'xml')
            return undefined;
        const matches = node.data.match(/\bencoding\s*=\s*(["'])([A-Za-z][A-Za-z0-9._-]*)\1/);
        return matches ? matches[2] : undefined;
    }
    async store(document) {
        const xml = new xmldom_1.XMLSerializer().serializeToString(document);
        const encoding = DOMStore.readEncodingName(document) || 'utf8';
        return new Promise((resolve, reject) => {
            this.writable.write(xml, encoding, (error) => error ? reject(error) : resolve());
        });
    }
}
exports.default = DOMStore;
//# sourceMappingURL=store.js.map