import xpath from 'xpath';
interface OperatorOptions {
    namespaces?: {
        [name: string]: string;
    };
    treeStructure?: [string, string][];
}
declare abstract class Operator {
    protected readonly distinct: boolean;
    protected readonly namespaces: {
        [name: string]: string;
    };
    protected readonly treeStructure: [string, string][];
    protected readonly select: xpath.XPathSelect;
    constructor(distinct?: boolean, options?: OperatorOptions);
    protected abstract needToRetain(oneContains: boolean, otherContains: boolean): boolean;
    protected abstract needToMergeOther(): boolean;
    operation(node1: Node, node2: Node, sink: Node): Node;
}
export declare class Union extends Operator {
    protected needToRetain(oneContains: boolean, otherContains: boolean): boolean;
    protected needToMergeOther(): boolean;
}
export declare class Intersect extends Operator {
    protected needToRetain(oneContains: boolean, otherContains: boolean): boolean;
    protected needToMergeOther(): boolean;
}
export declare class Except extends Operator {
    protected needToRetain(oneContains: boolean, otherContains: boolean): boolean;
    protected needToMergeOther(): boolean;
}
export {};
//# sourceMappingURL=operator.d.ts.map